local backdrop = {
  -- path to the background texture
  bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background",  
  -- path to the border texture
  edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border",
  -- true to repeat the background texture to fill the frame, false to scale it
  tile = true,
  -- size (width or height) of the square repeating background tiles (in pixels)
  tileSize = 32,
  -- thickness of edge segments and square size of edge corners (in pixels)
  edgeSize = 32,
  -- distance from the edges of the frame to those of the background texture (in pixels)
  insets = {
    left = 11,
    right = 12,
    top = 12,
    bottom = 11
  }
}

--main window
CreateFrame("Frame","EonTag_mainWindow",UIParent)
EonTag_mainWindow:SetWidth(200)
EonTag_mainWindow:SetHeight(300)
EonTag_mainWindow:SetMinResize(200,300);
EonTag_mainWindow:SetPoint("CENTER",0,0)
EonTag_mainWindow:SetMovable(true)
EonTag_mainWindow:EnableMouse(true)
EonTag_mainWindow:SetClampedToScreen(true)
EonTag_mainWindow:SetClampRectInsets(0,0,0,0)
EonTag_mainWindow:SetBackdrop(backdrop)
EonTag_mainWindow:SetFrameStrata("DIALOG")

EonTag_mainWindow:RegisterForDrag("LeftButton")
EonTag_mainWindow:SetScript("OnDragStart", EonTag_mainWindow.StartMoving)
EonTag_mainWindow:SetScript("OnDragStop", EonTag_mainWindow.StopMovingOrSizing)
EonTag_mainWindow:RegisterEvent("CHAT_MSG_ADDON", 
function(pre,message,ch,sender)
	print("Heard message:",message)
	if message == "Game started" then
		gameisactive = true;
		tag_master = sender
		EonTag_f()
		print(sender .. " started a game of tag")
	end
 
	if message == "Game ended" then
		gameisactive = false;
		print("Game ended")
	end

	if GetRaidTargetIndex(sender) == 4 and UnitInRaid("unit") ~= nil then
		tagged_unit = message;
		SetRaidTarget(sender,0)
		C_Timer.After(1,EonTag_red)
	end
	
	print(message,sender)
end)

EonTag_mainWindow:Hide();

--toaster frame
local ToasterAlpha = 0;
ToasterTextAlpha = 0;
ToasterSize = 35;
ToasterTargetSize = 35;

CreateFrame("Frame","EonTag_Toaster",EonTag_mainWindow)
EonTag_Toaster:SetPoint("TOPLEFT",EonTag_mainWindow,"BOTTOMLEFT",0,12)
EonTag_Toaster:SetPoint("TOPRIGHT",EonTag_mainWindow,"BOTTOMRIGHT",0,12)
EonTag_Toaster:SetBackdrop(backdrop)
EonTag_Toaster:SetMovable(true)
EonTag_Toaster:SetHeight(35)
EonTag_Toaster:SetScript("OnUpdate",function()
	
	if ToasterSize >= ToasterTargetSize - 1 and ToasterSize <= ToasterTargetSize + 1 then
		if ToasterTargetSize >= 37 then
			if ToasterTextAlpha < 0.95 then
				ToasterTextAlpha = ToasterTextAlpha + 0.03
			end
		else
			if ToasterAlpha > 0.03 then
				ToasterAlpha = ToasterAlpha - 0.03
			end
		end
	else
		if ToasterAlpha > 0.97 then
			if ToasterTextAlpha > 0.03 then
				ToasterTextAlpha = ToasterTextAlpha - 0.03
			else
				if ToasterSize < ToasterTargetSize - 1 then
					ToasterSize = ToasterSize + 1;
				end
				if ToasterSize > ToasterTargetSize then
					ToasterSize = ToasterSize - 1;
				end
				EonTag_Toaster_Text:SetText(EonTag_Toaster_Text_Measure:GetText())
			end
		else
			ToasterAlpha = ToasterAlpha + 0.03
		end
	end
	EonTag_Toaster:SetAlpha(ToasterAlpha)
	EonTag_Toaster:SetHeight(ToasterSize)
	EonTag_Toaster_Text:SetAlpha(ToasterTextAlpha)
end)

--toaster text
EonTag_Toaster_Text = EonTag_Toaster:CreateFontString(nil, "OVERLAY", "GameFontNormal")
EonTag_Toaster_Text:SetPoint("TOPLEFT",13,-14)
EonTag_Toaster_Text:SetPoint("TOPRIGHT",-14,14)
EonTag_Toaster_Text:SetJustifyH("LEFT")
EonTag_Toaster_Text:SetAlpha(0)
EonTag_Toaster_Text_Measure = EonTag_Toaster:CreateFontString(nil, "OVERLAY", "GameFontNormal")
EonTag_Toaster_Text_Measure:SetPoint("TOPLEFT",EonTag_Toaster_Text)
EonTag_Toaster_Text_Measure:SetPoint("TOPRIGHT",EonTag_Toaster_Text)
EonTag_Toaster_Text_Measure:SetJustifyH("LEFT")
EonTag_Toaster_Text_Measure:Hide()




SetToasterText = function(text)
	if type(text) ~= "string"	then
		return -1
	end
	
	EonTag_Toaster_Text_Measure:SetText(text)
	ToasterTargetSize = EonTag_Toaster_Text_Measure:GetHeight() + 28;
	if ToasterTargetSize < 35 then
		ToasterTargetSize = 35
	end
	if ToasterSize >= ToasterTargetSize - 1 and ToasterSize <= ToasterTargetSize + 1 then
		EonTag_Toaster_Text:SetText(text)
	end
	
	if text ~= "" then
		if timer ~= nil then
			timer:Cancel()
		end
		timer = C_Timer.NewTimer(text:len()*0.1 + 3,EmptyToaster)
	end
end

EmptyToaster = function()
	SetToasterText("")
end

local ClassColors = {}
ClassColors["DEATHKNIGHT"] = "C41F3B"
ClassColors["DEMONHUNTER"] = "A330C9"
ClassColors["DRUID"] = "FF7D0A"
ClassColors["HUNTER"] = "ABD473"
ClassColors["MAGE"] = "69CCF0"
ClassColors["MONK"] = "00FF96"
ClassColors["PALADIN"] = "F58CBA"
ClassColors["PRIEST"] = "FFFFFF"
ClassColors["ROUGE"] = "FFF569"
ClassColors["SHAMAN"] = "0070DE"
ClassColors["WARLOCK"] = "9582C9"
ClassColors["WARRIOR"] = "C79D6E"
ColorByClass = function(text,class)
	if ClassColors[class] ~= nil then
		return "|cFF"..ClassColors[class]..text.."|r"
	else
		return text
	end
end
target_NameFrameWidth = 185;
target_NameFrameHeight = 40;
lastnameframe = nil
ActivePlayerFrames = 0;
AddName = function(name,parent,class)
	local CurrentNameFrame = EonTag_PlayerFrames_Names[ActivePlayerFrames+1]
	ActivePlayerFrames = ActivePlayerFrames + 1
	if CurrentNameFrame == nil then
		CurrentNameFrame = EonTag_PlayersFrame:CreateFontString("EonTag_PlayernameFrame"..table.getn(EonTag_PlayerFrames_Names), "OVERLAY", "GameFontNormal")
		CurrentNameFrame:SetHeight(12)
		CurrentNameFrame:SetJustifyH("LEFT")
		CurrentNameFrame:SetAlpha(0)
		tinsert(EonTag_PlayerFrames_Names,CurrentNameFrame)
		if lastnameframe == nil then
			CurrentNameFrame:SetPoint("TOPLEFT",13,-14)
			CurrentNameFrame:SetPoint("TOPRIGHT",14,14)
			lastnameframe = CurrentNameFrame
		else
			CurrentNameFrame:SetPoint("TOPLEFT",lastnameframe,"BOTTOMLEFT")
			CurrentNameFrame:SetPoint("TOPRIGHT",lastnameframe,"BOTTOMRIGHT")
			lastnameframe = CurrentNameFrame
		end
	end
	
	if class ~= nil then
		CurrentNameFrame:SetText(ColorByClass(name,class))
	else
		_, englishClass, _ = UnitClass(name);
		CurrentNameFrame:SetText(ColorByClass(name,englishClass))
	end
	
	return CurrentNameFrame
end

EonTag_PlayersFrame_visible = false
UpdatePlayerWindowSize = function()
	target_NameFrameHeight = ActivePlayerFrames*12 + 28
	if ActivePlayerFrames > 0 then
		EonTag_PlayersFrame_visible = true;
	else
		EonTag_PlayersFrame_visible = false
		C_Timer.After(2,function() target_NameFrameHeight = 40 end)
	end
end

local purging = false
EonTag_Purge = function()
	EonTag_PlayersFrame_visible = false
	purging = true
end


CreateFrame("Frame","EonTag_PlayersFrame",EonTag_mainWindow)
EonTag_PlayersFrame:SetWidth(40)
EonTag_PlayersFrame:SetHeight(40)
EonTag_PlayersFrame:SetAlpha(0)
EonTag_PlayersFrame:SetPoint("TOPLEFT",EonTag_mainWindow,"TOPRIGHT",-14,0)
EonTag_PlayersFrame:SetBackdrop(backdrop)
EonTag_PlayersFrame:SetScript("OnUpdate",
	function()
		if EonTag_PlayersFrame_visible then
			if EonTag_PlayersFrame:GetHeight() > target_NameFrameHeight + 1 then
				EonTag_PlayersFrame:SetHeight(EonTag_PlayersFrame:GetHeight()-1)
			end
			if EonTag_PlayersFrame:GetHeight() < target_NameFrameHeight - 1 then
				EonTag_PlayersFrame:SetHeight(EonTag_PlayersFrame:GetHeight()+1)
			end
		
			if EonTag_PlayersFrame:GetAlpha() < 0.97 then
				EonTag_PlayersFrame:SetAlpha(EonTag_PlayersFrame:GetAlpha() + 0.03)
			else
				if EonTag_PlayersFrame:GetWidth() < target_NameFrameWidth then
					EonTag_PlayersFrame:SetWidth(EonTag_PlayersFrame:GetWidth() + 3)
				else
					for k,v in pairs(EonTag_PlayerFrames_Names) do
						if EonTag_LeftPlayer[1] ~= nil and k >= tmin(EonTag_LeftPlayer) and k <= ActivePlayerFrames then
							if v:GetAlpha() > 0.03 then
								v:SetAlpha(v:GetAlpha() - 0.03)
							else
								for _,index in pairs(EonTag_LeftPlayer) do
									for k,v in pairs(EonTag_PlayerFrames_Names) do
										if k >= index and k <= table.getn(EonTag_PlayerFrames_Names)-1 then
											EonTag_PlayerFrames_Names[k]:SetText(EonTag_PlayerFrames_Names[k+1]:GetText())
										end
									end
									EonTag_PlayerFrames_Names[table.getn(EonTag_PlayerFrames_Names)]:SetText("")
									ActivePlayerFrames = ActivePlayerFrames - 1
								end
								for k,v in pairs(EonTag_LeftPlayer) do EonTag_LeftPlayer[k]=nil end
								UpdatePlayerWindowSize()
								break
							end
						else
						
							if v:GetAlpha() < 0.97 and k <= ActivePlayerFrames then
								v:SetAlpha(v:GetAlpha() + 0.03)
							end
						end
					end
				end
			end
		else
			local HighestAlpha = 0.03;
			for k,v in pairs(EonTag_PlayerFrames_Names) do
				if v:GetAlpha() > HighestAlpha then
					HighestAlpha = v:GetAlpha()
					v:SetAlpha(v:GetAlpha() - 0.03)
				end
			end
			if HighestAlpha < 0.05 then
				if EonTag_PlayersFrame:GetWidth() > 40 then
					EonTag_PlayersFrame:SetWidth(EonTag_PlayersFrame:GetWidth() - 3)
				else
					if EonTag_PlayersFrame:GetAlpha() > 0.03 then
						EonTag_PlayersFrame:SetAlpha(EonTag_PlayersFrame:GetAlpha() - 0.03)
					else
						if purging then
							for k,v in pairs(EonTag_PlayerFrames_Names) do EonTag_PlayerFrames_Names[k]:SetText("") end
							ActivePlayerFrames = 0
							for k,v in pairs(JoinedPlayers) do JoinedPlayers[k]=nil end
							purging = false
							target_NameFrameHeight = 40
							EonTag_PlayersFrame:SetHeight(40)
						end
					end
				end
			end
		end
	end
)

EonTag_LeftPlayer = {}
EonTag_PlayerFrames_Names = {}
AddName("WWWWWWWWWWWW",EonTag_PlayersFrame,"SHAMAN")
ActivePlayerFrames = 0;
debug_ET_PlayerNameText = EonTag_PlayersFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
debug_ET_PlayerNameText:SetPoint("TOPLEFT",EonTag_PlayersFrame,"TOPRIGHT",-60,-14)
debug_ET_PlayerNameText:Hide()

local GameRequestWindowSize = {250,88}

EonTag_GameReqestActive = false
CreateFrame("Frame","EonTag_GameRequestFrame",UIParent)
EonTag_GameRequestFrame:SetBackdrop(backdrop)
EonTag_GameRequestFrame:SetPoint("TOPRIGHT",EonTag_mainWindow,"TOPLEFT",14,0)
EonTag_GameRequestFrame:SetHeight(40)
EonTag_GameRequestFrame:SetWidth(40)
EonTag_GameRequestFrame:SetAlpha(0)
EonTag_GameRequestFrame:SetScript("OnUpdate",function()
	if EonTag_GameReqestActive then
		if EonTag_GameRequestFrame:GetAlpha() < 0.94 then
			EonTag_GameRequestFrame:SetAlpha(EonTag_GameRequestFrame:GetAlpha() + 0.06)
		else
			if EonTag_GameRequestFrame:GetWidth() < GameRequestWindowSize[1] then
				EonTag_GameRequestFrame:SetWidth(EonTag_GameRequestFrame:GetWidth() + 5)
			end
			if EonTag_GameRequestFrame:GetHeight() < GameRequestWindowSize[2] then
				EonTag_GameRequestFrame:SetHeight(EonTag_GameRequestFrame:GetHeight() + 3)
			end
			for	k,v in pairs(EonTag_GameRequestFrame_Components) do
				if not v:IsVisible() then
					v:Show()
				end
				if EonTag_GameRequestFrame:GetLeft() < v:GetLeft()-14 and EonTag_GameRequestFrame:GetBottom() < v:GetBottom() then
					if v:GetAlpha() < 0.94 then
						v:SetAlpha(v:GetAlpha() + 0.06)
					end
				end
			end
		end
	else
	
		local HighestAlpha = 0.03;
		for	k,v in pairs(EonTag_GameRequestFrame_Components) do
			if v:GetAlpha() > HighestAlpha then
				HighestAlpha = v:GetAlpha()
				v:SetAlpha(v:GetAlpha() - 0.06)
			end
			if v:GetAlpha() < 0.06 then
				v:Hide()
			end
		end
		if HighestAlpha < 0.06 then
			if EonTag_GameRequestFrame:GetHeight() > 40 then
				EonTag_GameRequestFrame:SetHeight(EonTag_GameRequestFrame:GetHeight() - 3)
			end
			if EonTag_GameRequestFrame:GetWidth() > 40 then
				EonTag_GameRequestFrame:SetWidth(EonTag_GameRequestFrame:GetWidth() - 5)
			else
				if EonTag_GameRequestFrame:GetAlpha() > 0.06 then
					EonTag_GameRequestFrame:SetAlpha(EonTag_GameRequestFrame:GetAlpha()-0.06)
				end
			end
		end
	end
end)
EonTag_GameRequestFrame_Components = {}

CreateFrame("Button","EonTag_AcceptGameRequest_Button",EonTag_GameRequestFrame,"UIPanelButtonTemplate")
EonTag_AcceptGameRequest_Button:SetWidth(80)
EonTag_AcceptGameRequest_Button:SetHeight(22)
EonTag_AcceptGameRequest_Button:SetAlpha(0)
EonTag_AcceptGameRequest_Button:SetText("Of course")
EonTag_AcceptGameRequest_Button:SetPoint("TOPRIGHT",EonTag_GameRequestFrame,"TOPRIGHT",-GameRequestWindowSize[1]/2,-52)
EonTag_AcceptGameRequest_Button:SetScript("OnClick",function()
	EonTag_GameReqestActive = false
	SendToAll(addon_prefix,"im in")
end)

CreateFrame("Button","EonTag_RejectGameRequest_Button",EonTag_GameRequestFrame,"UIPanelButtonTemplate")
EonTag_RejectGameRequest_Button:SetWidth(80)
EonTag_RejectGameRequest_Button:SetHeight(22)
EonTag_RejectGameRequest_Button:SetAlpha(0)
EonTag_RejectGameRequest_Button:SetText("Hell naw")
EonTag_RejectGameRequest_Button:SetPoint("TOPLEFT",EonTag_GameRequestFrame,"TOPRIGHT",-GameRequestWindowSize[1]/2,-52)
EonTag_RejectGameRequest_Button:SetScript("OnClick",function()
	EonTag_GameReqestActive = false
end)

EonTag_GameRequestFrame:CreateFontString("EonTag_GameRequestText_Name","OVERLAY","GameFontNormal")
EonTag_GameRequestText_Name:SetPoint("TOP",EonTag_GameRequestFrame,"TOPRIGHT",-GameRequestWindowSize[1]/2,-14)
EonTag_GameRequestText_Name:SetAlpha(0)

EonTag_GameRequestFrame:CreateFontString("EonTag_GameRequestText_Flavor","OVERLAY","GameFontNormal")
EonTag_GameRequestText_Flavor:SetPoint("TOP",EonTag_GameRequestFrame,"TOPRIGHT",-GameRequestWindowSize[1]/2,-26)
EonTag_GameRequestText_Flavor:SetAlpha(0)
local _,EnClass = UnitClass(EonTag_PlayerName)
EonTag_GameRequestText_Flavor:SetText("Has started hosting a game of tag\ndo "..ColorByClass("you",EnClass).." want to join?")


tinsert(EonTag_GameRequestFrame_Components,EonTag_AcceptGameRequest_Button)
tinsert(EonTag_GameRequestFrame_Components,EonTag_RejectGameRequest_Button)
tinsert(EonTag_GameRequestFrame_Components,EonTag_GameRequestText_Name)
tinsert(EonTag_GameRequestFrame_Components,EonTag_GameRequestText_Flavor)

EonTag_mainWindow:CreateFontString("EonTag_TimerText_lbl","OVERLAY", "GameFontNormal")
EonTag_TimerText_lbl:SetPoint("TOPLEFT",13,-14)
EonTag_TimerText_lbl:SetJustifyH("LEFT")
EonTag_TimerText_lbl:SetText("Time Left: ")

EonTag_mainWindow:CreateFontString("EonTag_TimerText","OVERLAY", "GameFontNormal")
EonTag_TimerText:SetPoint("TOPLEFT",EonTag_TimerText_lbl,"TOPRIGHT")
EonTag_TimerText:SetPoint("TOPRIGHT",EonTag_mainWindow,-14,-14)
EonTag_TimerText:SetJustifyH("LEFT")

EonTag_StatsWindowTargetSize = {300,300}
EonTag_SetStatsWindowTargetSize = function(width,height)
	if width ~= nil and type(width) == 'number' then
		EonTag_StatsWindowTargetSize[1] = width
	end
	if height ~= nil and type(height) == 'number' then
		EonTag_StatsWindowTargetSize[1] = height
	end	
end

CreateFrame("Frame","EonTag_StatsWindow",EonTag_mainWindow)
EonTag_StatsWindow:SetPoint("BOTTOMRIGHT",EonTag_mainWindow,"TOPLEFT",(EonTag_mainWindow:GetRight()-EonTag_mainWindow:GetLeft())/2 + 7,-14)
EonTag_StatsWindow:SetBackdrop(backdrop)
EonTag_StatsWindow:SetScript("OnUpdate",function() 
	if EonTag_StatWindowOpen then
		if EonTag_StatsWindow:GetWidth() < EonTag_StatsWindowTargetSize[1] then
			EonTag_StatsWindow:SetWidth(EonTag_StatsWindow:GetWidth() + 2)
		end
	else
		
	end
end)

EonTag_StatsWindow:CreateFontString("EonTag_StatsText_names","OVERLAY", "GameFontNormal")
EonTag_StatsText_names:SetPoint("BOTTOMLEFT",EonTag_StatsWindow,14,14)
EonTag_StatsText_names:SetText("Game Stats:\nfiskos\nfiskboxone\nfiskboxtwo\nfiskboxthree")
EonTag_StatsText_names:SetJustifyH("LEFT")


EonTag_StatsWindow:CreateFontString("EonTag_StatsText_Scores","OVERLAY", "GameFontNormal")
EonTag_StatsText_Scores:SetPoint("BOTTOMRIGHT",EonTag_StatsWindow,-14,14)
EonTag_StatsText_Scores:SetJustifyH("RIGHT")

EonTag_StatsWindow:SetSize(EonTag_StatsText_names:GetWidth() + EonTag_StatsText_Scores:GetWidth() + 28,EonTag_StatsText_names:GetHeight() + 28)